<div *blockUI="blockUIName; template: pageBlockTemplate">
  <div *ngIf="!serverErr.status; else serverFailed">
    <!-- <div [class]="ticketsData && ticketsData.length>0?'card':''"> -->

    <div class="row col px-0 mx-0 mt-2">
      
      <!-- <div class="col-sm-10 col-md-10 px-0">
          <form class="form-inline">
              <div class="form-group">
                  <label>
                      <h3 class="card-title-material mb-0">Alerts</h3>
                  </label>
  
                  <input style="width: 80vw; max-width: calc(80vw - 150px); margin-left: 15px;" type="text" [(ngModel)]="filterVal" name="filterVal"
                   (input)="currentPage = 1; update()"
            class="form-control user-input-material" placeholder="Search..."> -->
  
                      <!-- <button type="button" class="btn icon-btn btn-sm btn-close" (click)="doClear()"><i class="ion ion-ios-close"></i></button> -->
  
              <!-- </div>
          </form>
      </div> -->

      <div class="col-md-12">
        <form class="form-inline">
            <div class="form-group w-100">
                <label>
                    <h3 class="card-title-material mb-0">Alerts</h3>
                </label>

                <input  class="form-control user-input-material ml-4 w-100" type="text" [(ngModel)]="filterVal" name="filterVal"
                (input)="currentPage = 1; update()" placeholder="Search...">

                    <div style="margin-right: 0; margin-left: auto;">
                      <div ngbDropdown placement="bottom-right">
                        <button *ngIf="!is_mobile_device && exploreList" class="btn btn-primary icon-only hide-arrow  pull-right"
                          placement="bottom" ngbDropdownToggle>
                          <i class="fas fa-plus"></i> Add Alert
                        </button>
                        <div ngbDropdownMenu class="cust-dropdown-menu">
                          <div *ngIf="exploreList && exploreList.length>0">
                            <a class="dropdown-item" *ngFor="let explore of exploreList;let i=index"
                              (click)="createAlert(createalert,'alert',i)">{{explore.entity_description}}</a>
                          </div>
                        </div>
                      </div>
                        </div>

            </div>
        </form>
    </div>



      <!-- <div class="col-sm-2 col-md-2 text-right px-0">
        <div ngbDropdown placement="bottom-right">
          <button *ngIf="!is_mobile_device && exploreList" class="btn btn-primary icon-only hide-arrow  "
            placement="bottom" ngbDropdownToggle>
            <i class="fas fa-plus"></i> Add Alert
          </button>
          <div ngbDropdownMenu class="cust-dropdown-menu">
            <div *ngIf="exploreList && exploreList.length>0">
              <a class="dropdown-item" *ngFor="let explore of exploreList;let i=index"
                (click)="createAlert(createalert,'alert',i)">{{explore.entity_description}}</a>
            </div>
          </div>
        </div>
      </div> -->

    </div>
    <hr class="hr-border container-m--x mt-3 mb-3">
    <div *ngIf="ticketsData && ticketsData.length>0; else emptyAlerts" class="card">
      <div class="card-body p-0">


        <div class="table-responsive">
          <table class="table table-sm table-striped table-dark table-mat-det table-t2hrs">
            <thead class="material-table-heading">
              <tr>
                <!-- <th class="text-nowrap cursor-pointer p-2" (click)="setSort('id')">
                ID<i class="ion text-muted ml-2" *ngIf="sortBy=='id'" [ngClass]="'ion-md-arrow-' + (sortDesc ? 'down' : 'up')"></i>
              </th> -->
                <th class="text-nowrap cursor-pointer p-2" (click)="setSort('displayalertname')">
                  <b>Name</b><i class="ion text-muted ml-2" *ngIf="sortBy=='displayalertname'"
                    [ngClass]="'ion-md-arrow-' + (sortDesc ? 'down' : 'up')"></i>
                </th>
                <th class="text-nowrap cursor-pointer p-2" (click)="setSort('alert_sql')">
                  <b>Condition</b><i class="ion text-muted ml-2" *ngIf="sortBy=='alert_sql'"
                    [ngClass]="'ion-md-arrow-' + (sortDesc ? 'down' : 'up')"></i>
                </th>
                <th class="text-nowrap cursor-pointer p-2">
                    <b>Filters</b><i class="ion text-muted ml-2"></i>
                </th>
                <th class="text-nowrap cursor-pointer p-2" (click)="setSort('alert_protocol')">
                    <b>Type</b><i class="ion text-muted ml-2" *ngIf="sortBy=='alert_protocol'"
                    [ngClass]="'ion-md-arrow-' + (sortDesc ? 'down' : 'up')"></i>
                </th>
                <th class="text-nowrap cursor-pointer p-2" (click)="setSort('alert_track_period')">
                    <b>Track Period</b><i class="ion text-muted ml-2" *ngIf="sortBy=='alert_track_period'"
                    [ngClass]="'ion-md-arrow-' + (sortDesc ? 'down' : 'up')"></i>
                </th>
                <th class="text-nowrap cursor-pointer p-2" (click)="setSort('trigger_frequency')">
                    <b>Trigger Frequency</b><i class="ion text-muted ml-2" *ngIf="sortBy=='trigger_frequency'"
                    [ngClass]="'ion-md-arrow-' + (sortDesc ? 'down' : 'up')"></i>
                </th>
                <th class="text-center text-nowrap cursor-pointer p-2">
                    <b>Actions</b><i class="ion text-muted ml-2"></i>
                </th>
                <!-- <th class="text-nowrap cursor-pointer p-2" (click)="setSort('recipient')">
                Recipient<i class="ion text-muted ml-2" *ngIf="sortBy=='recipient'" [ngClass]="'ion-md-arrow-' + (sortDesc ? 'down' : 'up')"></i>
              </th>
              <th class="text-nowrap cursor-pointer p-2" (click)="setSort('subject')">
                Alert Subject<i class="ion text-muted ml-2" *ngIf="sortBy=='subject'" [ngClass]="'ion-md-arrow-' + (sortDesc ? 'down' : 'up')"></i>
              </th>
              <th class="text-nowrap cursor-pointer p-2" (click)="setSort('alert_field')">
                Alert For<i class="ion text-muted ml-2" *ngIf="sortBy=='alert_field'" [ngClass]="'ion-md-arrow-' + (sortDesc ? 'down' : 'up')"></i>
              </th>
              <th class="text-nowrap cursor-pointer p-2" (click)="setSort('alert_sql')">
                Alert Condition<i class="ion text-muted ml-2" *ngIf="sortBy=='alert_sql'" [ngClass]="'ion-md-arrow-' + (sortDesc ? 'down' : 'up')"></i>
              </th>
              <th class="text-nowrap cursor-pointer p-2" (click)="setSort('lastupdatedate')">
                Last update<i class="ion text-muted ml-2" *ngIf="sortBy=='lastupdatedate'" [ngClass]="'ion-md-arrow-' + (sortDesc ? 'down' : 'up')"></i>
              </th> -->

                <!-- <th></th> -->
              </tr>
            </thead>
            <tbody class="table-body-customize">
              <tr *ngFor="let ticket of ticketsData">
                <!-- <td class="align-middle p-2">{{ticket.id}}</td> -->
                <td class="align-middle p-2">{{ticket.displayalertname}}</td>
                <td class="align-middle p-2">{{ticket.alert_sql}}</td>

                <td class="align-middle p-2">
                  <span class="ml-1 values-align" style="display:block" *ngFor="let option of ticket.filterdata">
                    {{option.object_display}}:{{option.object_id}}
                  </span>
                </td>
                <td class="align-middle p-2">{{ticket.alert_protocol}}</td>
                <td class="align-middle p-2">{{ticket.alert_track_period}}</td>
                <td class="align-middle p-2">{{ticket.trigger_frequency}}</td>
                <!-- <td class="align-middle p-2">{{ticket.recipient}}</td> -->
                <!-- <td class="align-midle py-3">{{ticket.subject}}</td> -->
                <!-- <td class="align-middle p-2">{{ticket.alert_field}}</td>
              <td class="align-middle p-2">{{ticket.alert_sql}}</td>
              <td class="align-middle p-2">{{ticket.lastupdatedate}}</td> -->

                <td class="text-center text-nowrap align-middle p-2">

                  <a href="javascript:void(0)" class="btn btn-default btn-xs icon-btn md-btn-flat"
                    (click)="TestRunAlert(ticket,AlertTestRunModal)"
                    style="width: calc(1.5rem + 2px) !important; line-height: 1.5rem;">
                    <!-- <i class="fas fa-clipboard-check"></i>--> Test</a>

                  <a href="javascript:void(0)" *ngIf="!deviceService.isMobile()"
                    class="btn btn-default btn-xs icon-btn md-btn-flat"
                    style="width: calc(1.5rem + 2px) !important; line-height: 1.5rem;">
                    <i class="ion ion-md-create"
                      (click)="openDialog(editalert, { windowClass: 'modal-fill-in modal-xlg modal-lg animate' },ticket,'editalert')"></i>
                  </a>

                  <a href="javascript:void(0)" class="btn btn-default btn-xs icon-btn md-btn-flat"
                    style="width: calc(1.5rem + 2px) !important; line-height: 1.5rem;">
                    <i class="ion ion-md-close"
                      (click)="openDialog(deleteConfirmModal, { windowClass: 'modal-fill-in modal-xlg modal-lg animate' },ticket,'deleteConfirmModal')"
                      style="width: calc(1.5rem + 2px) !important; line-height: 1.5rem;"></i></a>
                </td>
                <!-- <td ngIf="is_mobile_device" class="text-center text-nowrap align-middle p-2">
                  <a href="javascript:void(0)" class="btn btn-default btn-xs icon-btn md-btn-flat tooltipMob" (press)="onLongPress('Edit')"
                    (pressUp)="onPressUp()">
                    <span class="tooltiptext" *ngIf="mobTooltipStr != ''">{{mobTooltipStr}}</span><i class="ion ion-md-create"
                      (click)="openDialog(editalert, { windowClass: 'modal-fill-in modal-xlg modal-lg animate' },ticket,'editalert')"></i></a>
                  <a href="javascript:void(0)" class="btn btn-default btn-xs icon-btn md-btn-flat tooltipMob" (press)="onLongPress('Remove')"
                    (pressUp)="onPressUp()">
                    <span class="tooltiptext" *ngIf="mobTooltipStr != ''">{{mobTooltipStr}}</span><i class="ion ion-md-close"
                      (click)="openDialog(deleteConfirmModal, { windowClass: 'modal-fill-in modal-xlg modal-lg animate' },ticket,'deleteConfirmModal')"></i></a>
                </td>> -->
            </tbody>
          </table>
        </div>
        <!-- Pagination -->
        <div class="card-body py-0">
          <div class="row">
            <div class="col-sm text-sm-left text-center pt-3">
              <span class="text-muted" *ngIf="totalItems">Page {{ currentPage }} of {{ totalPages }}</span>
            </div>
            <div class="col-sm pt-3">
              <ngb-pagination [collectionSize]="totalItems" [pageSize]="perPage" [(page)]="currentPage"
                (pageChange)="update()" size="sm" class="d-flex justify-content-center justify-content-sm-end m-0">
              </ngb-pagination>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

<ng-template #emptyAlerts>
  <div *ngIf="ticketsData" class="emptyDiv">
    <figure>
      <img src="assets/imgs/hxIcon/emptydb.png" class="emptyDashboardImg">
      <figcaption><span class="emptyDashboardContent1">No Alerts Found.</span></figcaption>
    </figure>
  </div>
</ng-template>

<div class="card-body text-big text-center text-danger collapse-bg" style="text-align:center;" *ngIf="!ticketsData">
  <div style="height: 200px">

  </div>
</div>
<ng-template #pageBlockTemplate>
    <div class="block-ui-template">
      <div class="app-splash-screen ">
        <div class="new-app-splash-screen-content text-center">
        <img src="../../assets/img/hx-loader-logo.svg" class="loader-svg">
        <span class="loading-text-material">
         <!-- <p class="text-center text-white">{{loadingText}} </p> -->
     </span>
      </div>
      </div>
      <!-- <div class="sk-double-bounce sk-primary">
        <div class="sk-child sk-double-bounce1"></div>
        <div class="sk-child sk-double-bounce2"></div>
      </div>
      <span class="loading-text-material">
        <p class="text-center text-white"> {{loadingText}} </p>
      </span> -->

    </div>
  </ng-template>
<!-- start edit alert-->
<ng-template #editalert let-c="close" let-d="dismiss">
  <div class="modal-header">
    <h5 class="modal-title">
      Edit Alert Rule of <span class="font-weight-light">{{alertdetails.displayalertname}}</span><br>
      <!--  <small class="text-muted">We need payment information to process your order.</small> -->
    </h5>
    <button type="button" class="close" (click)="d('Cross click')">&times;</button>
  </div>
  <div class="modal-body material-style model-body-fixed">
    <!-- ORIGINAL -->
    <div class="ng2-archwizard-boxed-steps">
      <div [hidden]="alert_step_no!=1" navigationSymbol="&#62544;" navigationSymbolFontFamily="Ionicons">
        <ng-template wizardStepTitle>
          <div class="text-muted small">FIRST STEP - </div>Criteria
          </ng-template>
        <br>
        <div class="form-row form-content">
          <div class="form-group col-md-12">
            <div class="px-4 px-sm-5 pt-4 pb-5 pb-sm-5 title-heading-material">
              <label class="form-label">Alert Name</label>
              <span class="ml-2  " placement="bottom"
              ngbTooltip="Show add Alert Name">
              <i class="ion ion-ios-information-circle-outline ion-theme"></i>
            </span>
              <input type="text" class="form-control input-material" [(ngModel)]="alertdetails.displayalertname">
            </div>
          </div>



          <div class="form-group side-box-material col-md-6">
            <div class="px-4 px-sm-5 pt-4 pb-5 pb-sm-5 title-heading-material">
              <label class="form-label">Set Alert On</label>
              <span class="ml-2  " placement="bottom"
              ngbTooltip="To select Set Alert On">
              <i class="ion ion-ios-information-circle-outline ion-theme"></i>
            </span>
              <ng-select placeholder="Select Attribute" [options]="t_measures" [allowClear]="false" [(ngModel)]="alertdetails.alert_field"
              (ngModelChange)="changeFormat(alertdetails.alert_field)"  class="attribute_select_box">
            </ng-select>
            </div>
            <div class="px-4 px-sm-5 pt-4 pb-5 pb-sm-5 title-heading-material">
              <label class="form-label">Tracking Period
                <span class="ml-2  " placement="top"
                  ngbTooltip="Daily - Last Data Load Date
                  Weekly - 7 days from Last Data Load Date 
                  Monthly - 30 days from Data Load Date
                  Quarterly - 90 days from Data Load Date">
                  <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                </span>
              </label>
              <ng-select placeholder="E.g: Daily" searchable="false" dropdownPosition="top" [options]="tracking_period" [allowClear]="false" [(ngModel)]="alertdetails.alert_track_period"  class="attribute_select_box">
              </ng-select>
            </div>
          </div>
          
          <div class="form-group col-md-6 side-box-material">
            <div class="px-4 px-sm-5 pt-4 pb-5 pb-sm-5 title-heading-material">
              <label class="form-label">Alert Condition</label>
              <span class="ml-2  " placement="bottom"
              ngbTooltip="To select Alert Condition">
              <i class="ion ion-ios-information-circle-outline ion-theme"></i>
            </span>
            <ng-select placeholder="E.g: Daily" searchable="false" dropdownPosition="top"
             [options]="alert_condition_options" [allowClear]="false" [(ngModel)]="alertdetails.operator"  class="attribute_select_box">
              </ng-select>
             
            </div>

            <div class="px-4 px-sm-5 pt-4 pb-5 pb-sm-5 title-heading-material">
              <label class="form-label">Value{{alertSymbol}}</label>
              <span class="ml-2  " placement="bottom"
              ngbTooltip="To select Value">
              <i class="ion ion-ios-information-circle-outline ion-theme"></i>
            </span>
              <input type="text" id="checkvalue" [(ngModel)]="alertdetails.threshold" class="form-control">
            </div>

          </div>
        </div>

        <div class="modal-footer">
          <button type="button" class="btn btn-primary" (click)="next_step();">Next</button>
        </div>
      </div>

      <div [hidden]="alert_step_no!=2" navigationSymbol="&#62163;" navigationSymbolFontFamily="Ionicons">
        <ng-template wizardStepTitle>
          <div class="text-muted small">SECOND STEP</div>Filters
        </ng-template>
        <div class="form-row form-content">
          <div style="width:100%; height:50%" class="step-2-filetr">
            <hx-filter1 [resultData]="exploreData.hsresult" [filterNotifier]="filterNotifier"
              (toolApply)="toolApply($event)"></hx-filter1>
          </div>
        
        </div>
        <div class="modal-footer alert-model-footer">
          <button type="button" class="btn btn-default" (click)="previous_step();">Previous</button>
          <button type="button" class="btn btn-primary" (click)="next_step();">Next</button>
        </div>
      </div>

      <div [hidden]="alert_step_no!=3" navigationSymbol="&#62170;" navigationSymbolFontFamily="Ionicons">
        <ng-template wizardStepTitle>
          <div class="text-muted small">THIRD STEP</div>Triggers
        </ng-template>

        <span class="form-content">
          <div class="form-row step-three">


            <div class="form-group side-box-material col-md-6">
              <div class="px-4 px-sm-5 pt-4 pb-5 pb-sm-5 title-heading-material">
                <label class="form-label">Channel</label>
                <div>
                  {{alertdetails.alert_protocol}}
                </div>
              </div>
            </div>

            <div class="form-group side-box-material col-md-6">
              <div class="px-4 px-sm-5 pt-4 pb-5 pb-sm-5 title-heading-material">
                <label class="form-label">Trigger the Alert

                  <span class="ml-2  "
                    placement="top" ngbTooltip="Immediately - Every Data Load
                    Daily - Every Morning
                    Weekly - Every Monday
                    Monthly - First Day of the Month">
                    <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                  </span>
                </label>
                <select class="custom-select form-control" [(ngModel)]="alertdetails.trigger_frequency">
                  <option value="Immediately">Immediately</option>
                  <option value="Daily">Daily</option>
                  <option value="Weekly">Weekly</option>
                  <option value="Monthly">Monthly</option>
                </select>
              </div>
            </div>

          </div>
        </span>

        <div class="modal-footer alert-model-footer">
          <button type="button" class="btn btn-default" (click)="previous_step();">Previous</button>
          <button type="button" class="btn btn-primary"
            (click)="finishEditFunction(alertdetails)">Finish</button>
        </div>
      </div>
      
    </div>

  </div>
 
</ng-template>
<!-- end edit alert -->

<!-- DELETE CONFIRMATION POPUP -->
<ng-template #deleteConfirmModal let-c="close" let-d="dismiss" class="modal fade-scale">
  <div class="modal-header">
    <h2 class="modal-title confirm-dialog"><i class="fa fa-exclamation-circle" aria-hidden="true"></i>
      <span class="font-weight-light">Confirmation</span>
    </h2>

    <button type="button" class="close" (click)="d('Cross click')">&times;</button>
  </div>

  <div class="modal-body">
    <!-- <h3>Are you sure?</h3> -->
    <p class="unpin-text mb-0">Do you really want to delete this alert! This process cannot be undone.</p>
  </div>

  <div class="modal-footer">
    <button type="button" class="btn btn-primary btn-material"
      (click)="delete_alert(alertdetails);c('Close click')">Yes,
      delete it!</button>
    <button type="button" class="btn btn-default" (click)="c('Close click')">Cancel</button>
  </div>
</ng-template>
<!--DELETE CONFIRMATION POPUP -->

<!--- create alert -->
<ng-template #createalert let-c="close" let-d="dismiss">
  <div class="modal-header">
    <h5 class="modal-title">
      Add Alert Rules <br>
      <!--  <small class="text-muted">We need payment information to process your order.</small> -->
    </h5>
    <button type="button" class="close" (click)="d('Cross click')">&times;</button>
  </div>

  <div class="modal-body material-style model-body-fixed">
    <!-- ORIGINAL -->
    <div class="ng2-archwizard-boxed-steps">
      <div [hidden]="alert_step_no!=1" navigationSymbol="&#62544;" navigationSymbolFontFamily="Ionicons">
        <ng-template wizardStepTitle>
            <div class="text-muted small">FIRST STEP</div>Criteria
        </ng-template>
        <br>





        <div class="form-row form-content">
          <div class="form-group col-md-12">
            <div class="px-4 px-sm-5 pt-4 pb-5 pb-sm-5 title-heading-material">
              <label class="form-label">Alert Name</label>
              <span class="ml-2  " placement="bottom"
              ngbTooltip="Show add Alert Name">
              <i class="ion ion-ios-information-circle-outline ion-theme"></i>
            </span>
              <input type="text" class="form-control input-material" [(ngModel)]="alert_name">
            </div>
          </div>
          <div class="form-group side-box-material col-md-6">
            <div class="px-4 px-sm-5 pt-4 pb-5 pb-sm-5 title-heading-material">
              <label class="form-label">Set Alert On</label>
              <span class="ml-2  " placement="bottom"
              ngbTooltip="To select Set Alert On">
              <i class="ion ion-ios-information-circle-outline ion-theme"></i>
            </span>
            <ng-select placeholder="Select Attribute" [options]="t_measures" [allowClear]="false" [(ngModel)]="alert_measure"
              (ngModelChange)="changeFormat(alert_measure)" class="attribute_select_box">
            </ng-select>
             
            </div>
           
            <div class="px-4 px-sm-5 pt-4 pb-5 pb-sm-5 title-heading-material">
              <label class="form-label">Tracking Period
                <span class="ml-2  " placement="top"
                  ngbTooltip="Daily - Last Data Load Date
                  Weekly - 7 days from Last Data Load Date 
                  Monthly - 30 days from Data Load Date
                  Quarterly - 90 days from Data Load Date">
                  <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                </span>
              </label>
              <ng-select placeholder="E.g: Daily" searchable="false" dropdownPosition="top" [options]="tracking_period" [allowClear]="false" [(ngModel)]="alert_time_period"  class="attribute_select_box">
                </ng-select>
             
            </div>
          </div>
          <div class="form-group col-md-6 side-box-material">
            <div class="px-4 px-sm-5 pt-4 pb-5 pb-sm-5 title-heading-material">
              <label class="form-label">Alert Condition</label>
              <span class="ml-2  " placement="bottom"
              ngbTooltip="To select Alert Condition">
              <i class="ion ion-ios-information-circle-outline ion-theme"></i>
            </span>
            <ng-select placeholder="E.g: Daily" searchable="false" dropdownPosition="top"
             [options]="alert_condition_options" [allowClear]="false" [(ngModel)]="alert_condition"  class="attribute_select_box">
              </ng-select>
            
            </div>



            <div class="px-4 px-sm-5 pt-4 pb-5 pb-sm-5 title-heading-material">
              <label class="form-label">Value{{alertSymbol}}</label>
              <span class="ml-2  " placement="bottom"
              ngbTooltip="To select Alert Values">
              <i class="ion ion-ios-information-circle-outline ion-theme"></i>
            </span>
              <input type="text" id="checkvalue" [(ngModel)]="alert_value" class="form-control">
            </div>


          </div>

        </div>





        <div class="modal-footer alert-model-footer">
          <button type="button" class="btn btn-primary" (click)="next_step();">Next</button>
        </div>
      </div>

      <div [hidden]="alert_step_no!=2" navigationSymbol="&#62163;" navigationSymbolFontFamily="Ionicons">
        <ng-template wizardStepTitle>
          <div class="text-muted small">SECOND STEP</div>Filters
        </ng-template>




        <div class="form-row form-content">
          <div style="width:100%; height:50%" class="step-2-filetr">
            <hx-filter1 [resultData]="exploreData.hsresult" [filterNotifier]="filterNotifier"
              (toolApply)="toolApply($event)"></hx-filter1>
          </div>
       
        </div>


        <div class="modal-footer alert-model-footer">
          <button type="button" class="btn btn-default" (click)="previous_step();">Previous</button>
          <button type="button" class="btn btn-primary" (click)="next_step();">Next</button>
        </div>
      </div>

      <div [hidden]="alert_step_no!=3" navigationSymbol="&#62170;" navigationSymbolFontFamily="Ionicons">
        <ng-template wizardStepTitle>
          <div class="text-muted small">THIRD STEP</div>Triggers
        </ng-template>

        <span class="form-content">
          <div class="form-row step-three">
            <div class="form-group side-box-material col-md-6">
              <div class="px-4 px-sm-5 pt-4 pb-5 pb-sm-5 title-heading-material">
                <label class="form-label">Channel</label>
                <span class="ml-2  " placement="bottom"
              ngbTooltip="To Select type of Channel">
              <i class="ion ion-ios-information-circle-outline ion-theme"></i>
            </span>
                <select class="custom-select form-control" [(ngModel)]="alert_via">
                  <option *ngFor="let type of notificationType" [value]="type.value">{{type.label}}</option>
                </select>
              </div>
            </div>

            <div class="form-group side-box-material col-md-6">
              <div class="px-4 px-sm-5 pt-4 pb-5 pb-sm-5 title-heading-material">
                <label class="form-label">Trigger the Alert
                  <span class="ml-2  "
                    placement="top" ngbTooltip="Immediately - Every Data Load
                    Daily - Every Morning
                    Weekly - Every Monday
                    Monthly - First Day of the Month">
                    <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                  </span>
                </label>
                <select class="custom-select form-control" [(ngModel)]="trigger_frequency">
                  <option value="Immediately">Immediately</option>
                  <option value="Daily">Daily</option>
                  <option value="Weekly">Weekly</option>
                  <option value="Monthly">Monthly</option>
                </select>
              </div>
            </div>

          </div>
        </span>



        <div class="modal-footer alert-model-footer">
          <button type="button" class="btn btn-default" (click)="previous_step();">Previous</button>
          <button type="button" class="btn btn-primary" (click)="next_step();finishFunction('test')">Test</button>
          <button type="button" class="btn btn-primary" (click)="finishFunction('live')">Finish</button>
        </div>
      </div>
      <div [hidden]="alert_step_no!=4" navigationSymbol="&#62263;" navigationSymbolFontFamily="Ionicons">
        <ng-template wizardStepTitle>
          <div class="text-muted small">FOURTH STEP</div>Test
        </ng-template>


        <div>
          <div class="row row-con-fil">

            <div class="col-md-6 condition-mob" *ngIf="alert_measure!=''">
              <div class="notifi-filter pivot-table-dialog">
                <span class="ml-5 align-ment"> <span class="badge-default badge badge-secondary">
                    Conditions:</span></span>
                <span class="ml-1 values-align"> <span
                    class="info-badge">{{alert_measure}}{{alert_condition}}{{alert_value}}</span></span>
              </div>
            </div>
            <div class="col-md-6 filter-mob" *ngIf="filterData && filterData.length>0">
              <div class="notifi-filter pivot-table-dialog">
                <span class="ml-5 align-ment"> <span class="badge-default badge badge-secondary"> Filters
                    Appiled:</span></span>
                <span class="ml-1 values-align" *ngFor="let filter of filterData">{{filter.object_display}} <span
                    class="info-badge">{{filter.object_id}}</span></span>
              </div>
            </div>


          </div>

          <div *ngIf="pivotTestRunAlertResult && pivotTestRunAlertResult.dataSource.data.length >1; else noRecordResult"
            class="modal-body pivot-table-dialog">
            <fm-pivot #pivotcontainer [width]="'100%'" [height]="200" [toolbar]="false" [id]="pivot-container"
              [report]="pivotTestRunAlertResult" [global]=pivotGlobal
              [licenseKey]="'Z7TE-102510-6Z0345-61393B-585P5Q-3X053C-5F5P3O-1B2038-6T164M-6F1V6W-0K61'">
            </fm-pivot>
          </div>
        </div>


        <div class="modal-footer alert-model-footer">
          <button type="button" class="btn btn-default" (click)="previous_step();">Previous</button>
          <button type="button" class="btn btn-primary" (click)="finishFunction('live')">Finish</button>
        </div>
      </div>
    </div>

  </div>
  <!-- <div class="modal-footer">
          <button type="button" class="btn btn-default" (click)="c('Close click')">Close</button>
          <button type="button" class="btn btn-primary">Save</button>
        </div> -->
  <!-- <div class="modal-footer">
            <button type="button" style="padding: 1.2rem 1rem; background: none; border: none;"></button>
          </div> -->
</ng-template>
<!-- end create alert -->

<ng-template #AlertTestRunModal let-c="close" let-d="dismiss">
  <div class="modal-header pivot-table-dialog">
    <h5 class="modal-title">Alert Name : {{testAlertName}}<br></h5>
    <button type="button" class="close" (click)="d('Cross click')">&times;</button>
  </div>

  <!-- Row Filters -->
  <div class="row row-con-fil">

    <!-- Applied Condition -->
    <div class="col-md-6 condition-mob" *ngIf="alertConditions!=''">
      <div class="notifi-filter pivot-table-dialog">
        <span class="ml-5 align-ment"> <span class="badge-default badge badge-secondary"> Conditions:</span></span>
        <span class="ml-1 values-align"> <span class="info-badge">{{alertConditions}}</span></span>
      </div>
    </div>
    <!-- Applied Condition -->

    <!-- Applied filter -->
    <div class="col-md-6 filter-mob" *ngIf="alertFilters!=''">
      <div class="notifi-filter pivot-table-dialog">
        <span class="ml-5 align-ment"> <span class="badge-default badge badge-secondary"> Filters Appiled:</span></span>
        <span class="ml-1 values-align"> <span class="info-badge">{{alertFilters}}</span></span>
      </div>
    </div>
    <!-- Applied filter -->


  </div>
  <!-- Row Filters -->

  <div *ngIf="pivotTestRunAlertResult && pivotTestRunAlertResult.dataSource.data.length >1; else noRecordResult"
    class="modal-body pivot-table-dialog">
    <fm-pivot #pivotcontainer [width]="'100%'" [height]="380" [toolbar]="false" [id]="pivot-container"
      [report]="pivotTestRunAlertResult" [global]=pivotGlobal
      [licenseKey]="'Z7TE-102510-6Z0345-61393B-585P5Q-3X053C-5F5P3O-1B2038-6T164M-6F1V6W-0K61'">
    </fm-pivot>
  </div>
  <div class="modal-footer pivot-table-dialog">
    <button type="button" class="btn btn-default" (click)="c('Close click')">Close</button>
  </div>
</ng-template>

<ng-template #noRecordResult>
  <div *ngIf="!isFailedTest.status; else tryAgainLater" class="empty-data-bg" style="height:340px">
    <img _ngcontent-c9="" class="emptyDashboardImg alptyAlertImg" src="assets/imgs/hxIcon/emptydb.png" style="height: 80%">
    <p>No Data Match with this Alert Condition.</p>
  </div>
</ng-template>

<ng-template #tryAgainLater>
  <div class="empty-data-bg">
    <img _ngcontent-c9="" class="emptyDashboardImg alptyAlertImg" src="assets/imgs/hxIcon/emptydb.png">
    <p>{{isFailedTest.msg}}</p>
  </div>
</ng-template>

<ng-template #serverFailed>
  <div class="emptyDiv">
    <figure>
      <img src="assets/imgs/hxIcon/emptydb.png" class="emptyDashboardImg">
      <figcaption><span class="emptyDashboardContent1">{{serverErr.msg}}</span></figcaption>
    </figure>
  </div>
</ng-template>